// Author : Nicolas JEAN
// Date   : October 2001
// filename : define.h
// Copyright : Nicolas JEAN 2001 - 2005
// available on http://youpee.salemioche.com

#ifndef __define_h_
#define __define_h_

typedef struct { char *from; char*to; } def;
extern char *html_code[][];

#define DIESE_DEFINE     "<#define"
#define DIESE_BINDEFINE  "<#bindefine"
#define DIESE_DBGDEFINE  "<#dbg_define"
#define DIESE_UNDEFINE   "<#undef"
#define DIESE_VAR        "<#var"
#define DIESE_ENDVAR     "</#var>"
#define DIESE_LIST       "<#list"
#define DIESE_ENDLIST    "</#list>"
#define DIESE_TAB        "<#tab"
#define DIESE_ENDTAB     "</#tab>"
#define DIESE_DISHTMLENC "<#disable_htmlencode>"
#define DIESE_ENHTMLENC  "</#disable_htmlencode>"

#define BINDEF_STR  "<#%s/>"
#define LISTDEF_STR "<#%s.%d/>"
#define LISTSIZE_STR "<#%s.size/>"
#define TABDEF_STR "<#%s.%d/>"
#define TABSIZE_STR "<#%s.size/>"
#define TABLINEDEF_STR "<#%s.%d.%d/>"
#define TABLINESIZE_STR "<#%s.%d.size/>"

void list_replace ( FILE *in, FILE *out, char *line);
void add_to_define_array(char *from, char *to, def **defines, int *nb, int *lg);
void del_to_define_array(char *s1, def **defines, int *nb, int *lg);
void replace_in_define_array(char *from, char *to, def **defines);
void replace_or_add_in_define_array(char *from, char *to, def **defines, int *nb, int *lg);
void del_all_define_array(def **defines, int *nb, int *lg);
int do_replace ( char *line , def *changes);
int is_defined ( char *from);
int is_bindefined ( char *from);
void add_define(FILE *in, FILE *out, char *line);
void del_define(FILE *in, FILE *out, char *line);
void add_builtin_define(char *define, char *value);
void replace_builtin_define(char *define, char *value);
void add_bindefine(FILE *in, FILE *out, char *line);
void add_var(FILE *in, FILE *out, char *line);
void add_list(FILE *in, FILE *out, char *line);
void add_tab(FILE *in, FILE *out, char *line);
int do_defines ( char *line );
int do_builtin_defines ( char *line );
void add_stddefine(char *s1, char *s2);
void del_stddefine(char *s1);
void enable_html_encode(FILE *in, FILE *out, char *line);
void disable_html_encode(FILE *in, FILE *out, char *line);

#endif
