// Author : Nicolas JEAN
// Date   : October 2001
// filename : for.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com
#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/unistd.h>
#include <sys/wait.h>
#include "youpee.h"
#include "common.h"
#include "include.h"
#include "loop.h"
#include "define.h"

void do_loop(FILE *in, FILE *out, char *line) {
loop m;
char buf[MAX_LINE_LENGTH], forstr[MAX_LINE_LENGTH], *forrc;
int level = 1;
char param[MAX_LINE_LENGTH], iparam[MAX_LINE_LENGTH], *action, *cvs_field, *cvs_index;
int actionid;
int ifrom, ito, istep;
char *sistep;
char istr[MAX_LINE_LENGTH];
FILE *forfile;
char *list[MAX_NUMBER_LOOP_PARAM], *loop_file;
int nb_loop_param = 0;
int pid, i, j, k;
int p[2];
FILE *pin, *pout;

  m.nb_def = 0; m.lg_def = 0; m.nb = 0; m.defines = NULL;

  sprintf(param,LOOP_PARAM_STR, cvs_index = get_field(line, 2));
  add_to_define_array( param, "", &(m.defines), &(m.nb_def), &(m.lg_def) );
  action = get_field(line, 3);

  if ( !strncmp(action, LOOP_IN, strlen(LOOP_IN) ) && strlen(action) == strlen(LOOP_IN) ) {
    actionid = LOOP_ACTIONID_IN;
    while ( ( list[nb_loop_param] = get_field(line, nb_loop_param+4) ) ) nb_loop_param++;
    nb_loop_param--;
  }
  else  if ( !strncmp(action, LOOP_BETWEEN, strlen(LOOP_BETWEEN) ) ) {
    actionid = LOOP_ACTIONID_BETWEEN;
    ifrom = atoi(get_field(line,4));
    ito   = atoi(get_field(line,5));
    sistep = get_field(line,6);
    if (sistep && atoi(sistep)) istep = atoi(sistep);
    else istep = 1;
  }
  else  if ( !strncmp(action, LOOP_INFILE, strlen(LOOP_INFILE) ) ) {
    actionid = LOOP_ACTIONID_INFILE;
    forfile = fopen(loop_file = findPath(get_field(line,4), getenv(ENV_INCLUDEPATH)), "r");
    SHOW_DEP(loop_file);
  }
  else if ( !strncmp(action, LOOP_INCVS, strlen(LOOP_INCVS) ) ) {
    actionid = LOOP_ACTIONID_INCVS;
    forfile = fopen(loop_file = findPath(get_field(line,4), getenv(ENV_INCLUDEPATH)), "r");
    SHOW_DEP(loop_file);
  }
  else if ( !strncmp(action, LOOP_INSECTION, strlen(LOOP_INSECTION) ) ) {
    actionid = LOOP_ACTIONID_INSECTION;
    forfile = fopen(loop_file = findPath(get_field(line,4), getenv(ENV_INCLUDEPATH)), "r");
    SHOW_DEP(loop_file);
  }
  else
    return;

  while ( getstrline(buf, MAX_LINE_LENGTH, in) != NULL ) {
    if ( ! strncmp_sol(buf, DIESE_LOOP ) ) level++;
    if ( ! strncmp_sol(buf, DIESE_ENDLOOP) )
       level--;
    if ( level ) m.buf[m.nb++] = strdup(buf);
    else  break;
    if ( m.nb == MAX_NUMBER_OF_LINE_PER_LOOP ) {
       fprintf(stderr, __FILE__ ".%d: max number of line per loop reached", __LINE__);
       break;
    }
  }
  m.buf[m.nb] = 0x00;
  if ( ( actionid == LOOP_ACTIONID_INFILE || 
         actionid == LOOP_ACTIONID_INCVS  || 
         actionid == LOOP_ACTIONID_INSECTION ) && ! forfile ) return; 
  if ( actionid == LOOP_ACTIONID_BETWEEN &&  ( (ifrom > ito && istep > 0 ) || ( ifrom < ito && istep < 0 ) ) ) return; 
  if ( pipe(p) < 0  ) {
    fprintf(stderr, __FILE__ ".%d: can't create pipe \n",__LINE__);
    exit(1);
  } 

  switch ( pid = fork() ) {
    case -1:  fprintf(stderr, __FILE__ ".%d : can't fork \n", __LINE__);
              return;
    case 0:  close(p[0]);
             pout  = fdopen(p[1],"w");
             i=0;
             while (1) {
                j = 0;
                switch(actionid) {
                  case LOOP_ACTIONID_IN:
                    replace_in_define_array( param, list[i++], &(m.defines));
                    break;
 
                  case LOOP_ACTIONID_BETWEEN:
                    sprintf(istr,"%d", ifrom);
                    replace_in_define_array( param, istr, &(m.defines));
                    break;
 
                  case LOOP_ACTIONID_INFILE:
                    forrc = getstrline(forstr, MAX_LINE_LENGTH, forfile);
                    replace_in_define_array( param, removeRN(forstr), &(m.defines));
                    break;
                    
                  case LOOP_ACTIONID_INCVS:
                    forrc = getstrline(forstr, MAX_LINE_LENGTH, forfile);
                    replace_in_define_array( param, removeRN(forstr), &(m.defines));
                    k=1;
                    while ( ( cvs_field = get_field(forstr, k) ) ) {
                      sprintf(iparam,LOOP_PARAM_CVS_STR, cvs_index, k);
                      replace_or_add_in_define_array( strdup(iparam), cvs_field, &(m.defines),
                                                      &(m.nb_def), &(m.lg_def));
                      k++;
                    }
                    break;

                  case LOOP_ACTIONID_INSECTION:
                    do {
                      forrc = getstrline(forstr, MAX_LINE_LENGTH, forfile);
                      if ( forstr[0] == '@' && forstr[1] == '@' ) {
                        replace_in_define_array( param, get_field(forstr,2), &(m.defines));
                        break;
                      }
                    } while ( forrc );
                    if ( !forrc ) break;
                    do {
                      forrc = getstrline(forstr, MAX_LINE_LENGTH, forfile);
                      sprintf(iparam,LOOP_PARAM_SECTION_STR, cvs_index, get_field(forstr,1));
                      replace_or_add_in_define_array( strdup(iparam), get_field(forstr,2), &(m.defines),
                                                      &(m.nb_def), &(m.lg_def));
                    } while ( forrc && strlen(forstr) > 3 );
                    break;
                }
                if ( ( actionid == LOOP_ACTIONID_INFILE    || 
                       actionid == LOOP_ACTIONID_INSECTION || 
                       actionid == LOOP_ACTIONID_INCVS ) && ! forrc ) break; 
                while ( m.buf[j] ) {
                  strcpy(buf, m.buf[j]);
                  do_replace(buf, m.defines);
                  fputs(buf, pout);
                  j++;
                }
                
                if ( actionid == LOOP_ACTIONID_INCVS ) {
                    while ( --k ) {
                      sprintf(iparam,LOOP_PARAM_CVS_STR, cvs_index, k);
                      replace_in_define_array( strdup(iparam), NULL, &(m.defines));
                    }
                }
                
                if ( actionid == LOOP_ACTIONID_IN && i == nb_loop_param ) break;
                if ( actionid == LOOP_ACTIONID_BETWEEN ) {
                  if ( (ifrom >= ito && istep > 0 ) || ( ifrom <= ito && istep <0 ) ) break;
                  ifrom += istep; 
                }
             }
             fflush(pout);
             close(p[1]); fclose(pout);
             if ( actionid == LOOP_ACTIONID_INFILE || actionid == LOOP_ACTIONID_INCVS ) fclose(forfile); 
             exit(0);
             break;
    default: close(p[1]);
             pin = fdopen(p[0],"r");
             process_file(pin, out, NULL);
             if ( waitpid(pid, NULL, 0) < 0 ) exit(1);
             close(p[0]); fclose(pin);
             break;
  }

}
