// Author : Nicolas JEAN
// Date   : October 2001
// filename : macro.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/unistd.h>
#include <sys/wait.h>
#include "youpee.h"
#include "common.h"
#include "macro.h"

macro macros[MAX_NUMBER_OF_MACRO];
int nb_macro=0; // number of defined macros

void do_createMacro(FILE *in, FILE *out, char *line) {
char buf[MAX_LINE_LENGTH];
int level = 1;
macro *m = &macros[nb_macro++];
char macro_bd[255], callmacro_bd[255];

  m->name = get_field(line, 2);
  m->nb_def = 0; m->lg_def = 0; m->nb = 0;

  while ( getstrline(buf, MAX_LINE_LENGTH, in) != NULL ) {
   if ( ! strncmp_sol(buf, DIESE_MACRO ) ) level++;
   if ( ! strncmp_sol(buf, DIESE_ENDMACRO) )
      level--;
   if ( level ) m->buf[m->nb++] = strdup(buf);
   else  break;
   if ( m->nb == MAX_NUMBER_OF_LINE_PER_MACRO ) {
      fprintf(stderr, __FILE__ ".%d: max number of line per macro reached, %s is truncated", __LINE__, m->name);
      break;
   }
 }
 m->buf[m->nb] = 0x00;
 sprintf(macro_bd,DIESE_MACRO_SHORTCUT_STR,m->name);
 sprintf(callmacro_bd,DIESE_CALLMACRO_STR,m->name);
 add_builtin_define(strdup(macro_bd),strdup(callmacro_bd));

}

void do_callMacro(FILE *in, FILE *out, char *line) {
char *name = get_field(line, 2);
macro *m = NULL;
int i , j = 0;
char *pv, pn[5], newline[MAX_LINE_LENGTH];
int pid;
int p[2];
FILE *pin, *pout;

  // find the macro
  for( i=0; i < nb_macro && !m; i++ )
    if ( !strcmp(name, macros[i].name) && 
         strlen(name) == strlen(macros[i].name) ) {
      m = &macros[i];
      break;
    }

  if ( ! m ) return;
  // fork and process the result
  if ( pipe(p) < 0  ) {
    fprintf(stderr, __FILE__ ".%d: can't create pipe \n",__LINE__);
    exit(1);
  } 

  switch ( pid = fork() ) {
   case -1:  fprintf(stderr, __FILE__ ".%d : can't fork \n", __LINE__);
             return;
   case 0:  close(p[0]);
            pout  = fdopen(p[1],"w");
            // create the local define
            j = 3; i = 1;
            while ( ( pv = get_field(line, j++) ) ) {
              if ( !pv || ! strcmp(pv, DIESE_ENDCALLMACRO ) ) break;
              sprintf(pn, MACRO_PARAM_STR , i++);
              add_to_define_array( strdup(pn), pv, &(m->defines), &(m->nb_def), &(m->lg_def) );
            }
            j=0;
            while ( m->buf[j] ) {
              strcpy(newline, m->buf[j]);
              do_replace(newline , m->defines);
              fputs(newline,pout);
              j++;
            }
            fflush(pout);
            close(p[1]); fclose(pout);
            exit(0);
            break;
   default: close(p[1]);
            pin = fdopen(p[0],"r");
            process_file(pin, out, NULL);
            if ( waitpid(pid, NULL, 0) < 0 ) exit(1);
            close(p[0]); fclose(pin);
            break;
  }

}

