// Author : Nicolas JEAN
// Date   : October 2001
// filename : post.c
// Copyright : Nicolas JEAN 2001 - 2004
// available on http://youpee.salemioche.com

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/unistd.h>
#include <sys/wait.h>
#include "youpee.h"
#include "post.h"
#include "common.h"

void do_execpost(char *binary, char **argv, FILE *out, int in) {
int pid;
int p[2];
FILE *pin;

  pipe(p);
  switch ( pid = fork() ) {
   case -1:  fprintf(stderr, __FILE__ ".%d : can't fork\n", __LINE__ );
             return;
   case 0:  close(p[0]);
            dup2(in, STDIN_FILENO);
            dup2(p[1], STDOUT_FILENO);
            execv(binary, argv);
            break;
   default: close(p[1]);
            pin  = fdopen(p[0],"r");
            process_file(pin, out, NULL);
            fclose(pin); close(p[0]);
            break;
  }
}

void do_post(FILE *in, FILE *out, char *line) {
char *codepath = getenv(ENV_CODEPATH);
char *binary = findPath(get_field(line, 2), codepath);
char *argv[2], buf[MAX_LINE_LENGTH];
int argc = 0;
int pid, level;
int p[2];
FILE *pout;

  if ( !binary ) return;
  SHOW_DEP(binary);
  argv[argc++] = binary;
  argv[argc] = 0x00;

  pipe(p);

  switch ( pid = fork() ) {
   case -1:  fprintf(stderr, __FILE__ ".%d : can't fork\n", __LINE__ );
             return;
             
   case 0:  close(p[0]);
            pout  = fdopen(p[1],"w");
            fclose(out);
            level = 1;
            while ( getstrline(buf, MAX_LINE_LENGTH, in) != NULL ) {
              if ( ! strncmp_sol(buf, DIESE_POST ) ) level++;
              if ( ! strncmp_sol(buf, DIESE_ENDPOST) ) level--;
              if ( level ) fprintf(pout, buf);
              else  break;
            }
            fclose(in);
            exit(0);
            break;

   default: close(p[1]);
            level = 1;
            while ( getstrline(buf, MAX_LINE_LENGTH, in) != NULL ) {
              if ( ! strncmp_sol(buf, DIESE_POST ) ) level++;
              if ( ! strncmp_sol(buf, DIESE_ENDPOST) ) level--;
              if ( ! level ) break;
            }
            do_execpost(binary, argv, out, p[0]);
            break;
  }

}

